/**
 * Copyright  2008 Kevin Twidle, Imperial College, London, England.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Contact: Kevin Twidle <kpt@doc.ic.ac.uk>
 *
 * Created on Jul 29, 2009
 *
 * $Log:$
 */

package net.ponder2.managedobject;

import net.ponder2.ManagedObject;
import net.ponder2.apt.Ponder2op;

/**
 * TODO Description
 * 
 * @author Kevin Twidle
 * @version $Id:$
 */
public class Mine implements ManagedObject {

	private int sizex, sizey;
	private int goldx, goldy;

	@Ponder2op("create")
	Mine() {
	}

	@Ponder2op("sizex:sizey:")
	void setSize(int x, int y) {
		this.sizex = x;
		this.sizey = y;
	}

	@Ponder2op("goldx:goldy:")
	void setGold(int goldx, int goldy) {
		this.goldx = goldx;
		this.goldy = goldy;
	}

	@Ponder2op("gscx:gscy:")
	protected boolean gsc(int x, int y) {
		return x == goldx && y == goldy;
	}

	@Ponder2op("wallFacing:x:y:")
	protected boolean wall(String facing, int x, int y) {
		char dir = facing.charAt(0);
		boolean result = false;
		switch (dir) {
		case 'n':
			if (y <= 0)
				result = true;
			break;
		case 'e':
			if (x >= sizex)
				result = true;
			break;
		case 's':
			if (y >= sizey)
				result = true;
			break;
		case 'w':
			if (x <= 0)
				result = true;
			break;
		}
		return result;
	}

}
