/**
 * Copyright  2008 Kevin Twidle, Imperial College, London, England.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Contact: Kevin Twidle <kpt@doc.ic.ac.uk>
 *
 * Created on Aug 4, 2009
 *
 * $Log:$
 */

package net.ponder2.managedobject;

import java.util.List;
import java.util.Vector;

import net.ponder2.ManagedObject;
import net.ponder2.apt.Ponder2op;
import net.ponder2.exception.Ponder2Exception;
import net.ponder2.objects.P2Hash;
import net.ponder2.objects.P2Object;

/**
 * TODO Description
 * 
 * @author Kevin Twidle
 * @version $Id:$
 */
public class Percepts extends P2Hash implements ManagedObject {

	List<P2Object> rulesets;

	@Ponder2op("create")
	Percepts() {
		rulesets = new Vector<P2Object>();
	}

	@Override
	@Ponder2op("asHash")
	public P2Hash asHash() {
		return this;
	}

	@Ponder2op("tell:")
	protected void tell(P2Object runset) {
		rulesets.add(runset);
	}

	@Ponder2op("at:put:")
	public synchronized P2Object atPut(P2Object source, String aKey, P2Object anObject)
			throws Ponder2Exception {
		if (super.operation_has(aKey)) {
			P2Object oldValue = super.operation_at(aKey);
			if (oldValue.equals(anObject))
				return anObject;
		}
		super.operation_at_put(aKey, anObject);
		event(source);
		return anObject;
	}

	@Ponder2op("event")
	protected void event(P2Object source) throws Ponder2Exception {
		if (rulesets.size() > 0) {
			if (TrRuleSet.Trace)
				System.out.println("Percepts: new event");
			for (P2Object ruleset : rulesets) {
				ruleset.operation(source, "event");
			}
		}
	}

}
